/* Serial port reader for multimeter data */
/* plotutils plotter here*/
/* NO GTK/GDK stuff yet */

/* Make with: make -f PowerClientv1_Makefile */

/* Simple ethernet CLIENT code:
 * USe as: Powerclient <servername> <portnum>
 * (i.e. simpleclient karelian 1234
 * only need to change the net loop to modify receiver
 *receives what is sscanf'ed from (buffer + index * 21)
 * 
 * lowpowered by: canturk isci / canturk@princeton.edu / YALLAH TURBO!
 */


/* NOT: THIS IS USING THE NOT THREAD SAFE VERSION,
FOR THREAD SAFE VERSION REFER TO MY CHINA LIBPLOT BOOKMARK */

#define _REENTRANT

#include <math.h>
#include <pthread.h>
#include <unistd.h> /* SLEEP AND USLEEP HERE */

#include <stdio.h>
#include <stdlib.h>

#include "plot.h" /* for plotting */
/* ether stuff*/
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define NET_ERROR -1
#define BACKLOG 5

/* ALL 24 COUNTED EVENTS */
enum {   eventcount_IOQallocation =0, eventcount_FSBdataactivity,  eventcount_BSQcacheref,
         eventcount_ITLBref,          eventcount_branchretired,    eventcount_BPUfetchreq,
         eventcount_LDportreplay,     eventcount_STportreplay,     eventcount_Frontend,
         eventcount_UOPtype,          eventcount_MOBloadreplay,    eventcount_machineclear,
         eventcount_UOPqueuewrites07, eventcount_PackedSPuop,      eventcount_PackedDPuop,
         eventcount_scalarSPuop,      eventcount_scalarDPuop,      eventcount_64bitMMXuop,
         eventcount_128bitMMXuop,     eventcount_x87FPuop,         eventcount_x87SIMDmovesuop,
         eventcount_TCdelivermode,    eventcount_UOPqueuewrites04, eventcount_UOPSretired, /*23*/
         NUM_EVENTS /*24*/
};

char event_name[NUM_EVENTS][64] =
{
         "IOQallocation",  "FSBdataactivity",  "BSQcacheref",
         "ITLBref",          "branchretired",    "BPUfetchreq",
         "LDportreplay",     "STportreplay",     "Frontend",
         "UOPtype",          "MOBloadreplay",    "machineclear",
         "UOPqueuewrites07", "PackedSPuop",      "PackedDPuop",
         "scalarSPuop",      "scalarDPuop",      "64bitMMXuop",
         "128bitMMXuop",     "x87FPuop",         "x87SIMDmovesuop",
         "TCdelivermode",    "UOPqueuewrites04", "UOPSretired"
};

#define get_event_name(eventno) \
        ((eventno>=0 && eventno < NUM_EVENTS) ? event_name[eventno] : "unknown event")

enum {   Bus_Control=0, L2,   BPU2ND, ITLB, L1,  MOB, MEMcont,
         DTLB,          INTE, FPE,    INTR, FPR, ID,  TC,
         BPU1ST,        ROM,  ALLOC,  REN,  IQ,  IQ2, SCH,
         RETIRE,        NUM_COMPONENTS /*22*/ };

char component_name[NUM_COMPONENTS][64] =
{
         "Bus Control", "L2 Cache",    "2nd Level BPU", "ITLB & Fetch", "L1 cache",
         "MOB",         "MEM control", "Data TLB",      "INT Exec",     "FP Exec",
         "INT Regfile", "FP Regfile",  "Inst Dec",      "Trace Cache",  "1st Level BPU",
         "Ucode ROM",   "Allocation",  "Rename",        "Inst Queue1",  "Inst Queue2",
         "Schedule",    "RETIRE"};
#define get_comp_name(compno) \
        ((compno>=0 && compno < NUM_COMPONENTS) ? component_name[compno] : "unknown comp")

#define MAX(a,b) ((a < b) ? b : a)
#define MIN(a,b) ((a < b) ? a : b)

double component_powers[NUM_COMPONENTS];
double access_rates[NUM_COMPONENTS];

#define MAX_POWER 72.0
#define IDLE_POWER 8.0
/* Percentile areas */
#define BUS_AREA 0.054
#define L2_AREA 0.147
#define BPU2ND_AREA 0.034
#define ITLB_AREA 0.016
#define MOB_AREA 0.027
#define ID_AREA 0.032
#define BPU1ST_AREA 0.049
#define TC_AREA 0.086
#define L1_AREA 0.058
#define DTLB_AREA 0.032
#define FPE_AREA 0.062
#define ROM_AREA 0.03
#define FPR_AREA 0.025
#define RETIRE_AREA 0.065
#define MEMCONT_AREA 0.01
#define INTE_AREA 0.02 /*int exec.*/
#define INTR_AREA 0.02 /*int regfile */
#define IQ_AREA 0.02
#define SCH_AREA 0.033
#define IQ2_AREA 0.042
#define ALLOC_AREA 0.017
#define REN_AREA 0.023

#define MAX_CHAR 127

FILE *serial; /* will be serial port stream*/
/* works with 9600 BAUD and no parity 8 bit */

pthread_mutex_t port_mutex; /* mutex object */

double serial_data;
float  average;
int    sample_no;
double sec = 0.0;

int handle; /* to be accessed by main and plotter*/
int BARhandle; /* to be accessed by main and plotter*/

int cpu_sock; /* fantazi icin burda pointer geciriyom manyaam ya*/

int init_network(char *server, char *port)
{
  char servername[MAX_CHAR];
  struct hostent *resolve;
  struct sockaddr_in server_addr;
  int status, sock, portnum;

  strncpy(servername, server, sizeof(servername));
  portnum = atoi(port);
  sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (sock == NET_ERROR)
  {
    perror("socket()");
    exit(2);
  }
  resolve = gethostbyname(servername);
  if (resolve == NULL)
  {
    resolve = gethostbyaddr(servername, strlen(servername), AF_INET);
    if (resolve == NULL)
    {
      perror("gethostbyname()");
      exit(2);
    }
  }
  memcpy(&server_addr.sin_addr, resolve->h_addr, resolve->h_length);
  server_addr.sin_family = AF_INET;
  server_addr.sin_port = htons(portnum);
  fprintf(stdout, "Client: trying %s on port %d\n", inet_ntoa(server_addr.sin_addr), portnum);
  status = connect(sock, &server_addr, sizeof(server_addr));
  if (status == NET_ERROR)
  {
    perror("connect()");
    exit(3);
  }
  return sock;
}

int socket_read(int sock, char *buffer, int len)
{
  int result;

  result = read(sock, buffer, len);
  if (result < 0) {
    perror("socket_read");
    exit(-1);
  }

  return result;
}


int plotter(double timestampp, double powerstamp, double modeledpower)
{
  int ind;
  char str[8];
  static double time_window[250] = {0.0};
  static double Measured_power_samples[250] = {0.0};
  static double Modeled_power_samples[250] = {0.0};
  static double Measured_current_MAX=0.0;
  static double Modeled_current_MAX=0.0;

  pl_selectpl (handle);       /* select the Plotter for use */
  time_window[249] = timestampp;
  if (powerstamp > 89)
    Measured_power_samples[249] = 1.0;
  else
    Measured_power_samples[249] = powerstamp;
  Modeled_power_samples[249] = modeledpower;

  if (Measured_current_MAX < Measured_power_samples[249])
    Measured_current_MAX = Measured_power_samples[249];
  if (Modeled_current_MAX < Modeled_power_samples[249])
    Modeled_current_MAX = Modeled_power_samples[249];

  pl_flinewidth (0.5);       /* line thickness in user coordinates */
  pl_pencolorname ("black");    /* path will be drawn in red */
  pl_fmove (0.0, 0.0);    /* position the graphics cursor */

  /* Last chance to erase stuff*/
  pl_erase ();                /* erase Plotter's graphics display */

  /* X axis */
  pl_fcontrel (100.0, 0.0);
  pl_fcont (99.0, 1.0);
  pl_fline (100.0, 0.0, 99.0, -1.0);
  /* Y axis */
  pl_fline (0.0, 0.0, 0.0, 75.0);
  pl_fline (0.0, 75.0, -1.0, 74.0);
  pl_fline (0.0, 75.0, 1.0, 74.0);
  /* draw the bounding line at the time end*/
  pl_pencolorname ("darkgray");    /* path will be drawn in red */
  pl_linemod ("shortdashed");
  pl_fline (100.0, 5.0, 100.0, 75.0);

  pl_pencolorname ("black");    /* path will be drawn in red */
  pl_linemod ("solid");
  pl_flinewidth (0.2);       /* line thickness in user coordinates */
  /* x axis ticks*/
  pl_fline (10.0, 1.0, 10.0, -1.0);
  pl_fline (20.0, 1.0, 20.0, -1.0);
  pl_fline (30.0, 1.0, 30.0, -1.0);
  pl_fline (40.0, 1.0, 40.0, -1.0);
  pl_fline (50.0, 1.0, 50.0, -1.0);
  pl_fline (60.0, 1.0, 60.0, -1.0);
  pl_fline (70.0, 1.0, 70.0, -1.0);
  pl_fline (80.0, 1.0, 80.0, -1.0);
  pl_fline (90.0, 1.0, 90.0, -1.0);
  /* y axis ticks*/
  pl_fline (1.0, 10.0, -1.0, 10.0);
  pl_fline (1.0, 20.0, -1.0, 20.0);
  pl_fline (1.0, 30.0, -1.0, 30.0);
  pl_fline (1.0, 40.0, -1.0, 40.0);
  pl_fline (1.0, 50.0, -1.0, 50.0);
  pl_fline (1.0, 60.0, -1.0, 60.0);
  pl_fline (1.0, 70.0, -1.0, 70.0);

  /* Set string attributes */
  pl_fontname ("NewCenturySchlbk-Roman"); /* choose a Postscript font */
  pl_ffontsize (4.0);
  /* write Y axis values */
  for (ind=70; ind >= 0; ind=ind - 10)
  {
    pl_fmove (-2.0, (double) ind);
    sprintf(str, "%2d", ind);
    pl_alabel ('r', 'c', str);
  }
  /* write Y label */
  pl_fmove (-12.0, 35.0);
  pl_ffontsize (5.0);
  pl_textangle(90);
  pl_alabel ('c', 'c', "CPU Power [W]");
  pl_textangle(0);

  /* arrange the sliding X axis */
  pl_pencolorname ("blue");    /* path will be drawn in red */
  pl_ffontsize (3.0);
  for (ind=0; ind < 100; ind=ind + 10)
  {
    pl_fmove ((double) ind, -2.0);
    sprintf(str, "%5.1f", time_window[ind*5/2]);
    pl_alabel ('c', 't', str);
  }
  /* write X label */
  pl_pencolorname ("darkblue");    /* path will be drawn in red */
  pl_fontname ("helvetica"); /* choose a Postscript font */
  pl_fmove (50.0, -10.0);
  pl_ffontsize (5.0);
  pl_alabel ('c', 'c', "Sliding Time [s]");

  /* write TITLE */
  pl_pencolorname ("firebrick3");    /* path will be drawn in red */
  pl_fmove (50.0, 85.0);
  pl_ffontsize (6.0);
  pl_alabel ('c', 'c', "MEASURED/MODELED CPU POWER vs TIME");

  /*PRINT MEASURED max */
  pl_pencolorname ("darkblue");
  pl_flinewidth (0.4);       /* line thickness in user coordinates */
  pl_fillcolorname("aquamarine");
  pl_filltype(1);
  pl_fbox(80.0,70.0, 119.0, 80.0);
  pl_filltype(0);
  pl_fmove (100.0, 75.0);
  pl_ffontsize (4.0);
  pl_pencolorname ("lightsalmon4");    /* path will be drawn in red */
  sprintf(str, "MAX Power: %5.3f", Measured_current_MAX);
  pl_alabel ('c', 'c', str);
  /*PRINT MODELED max */
  pl_pencolorname ("darkblue");
  pl_flinewidth (0.4);       /* line thickness in user coordinates */
  pl_fillcolorname("aquamarine");
  pl_filltype(1);
  pl_fbox(80.0,60.0, 119.0, 70.0);
  pl_filltype(0);
  pl_fmove (100.0, 65.0);
  pl_ffontsize (4.0);
  pl_pencolorname ("lightsalmon4");    /* path will be drawn in red */
  sprintf(str, "MAX Power: %5.3f", Modeled_current_MAX);
  pl_alabel ('c', 'c', str);

  /* plot it already - MEASURED */
  pl_pencolorname ("red");    /* path will be drawn in red */
  pl_flinewidth (0.4);       /* line thickness in user coordinates */
  pl_fmove(0.0,Measured_power_samples[0]);
  for (ind=1; ind<250; ind++)
  {
    pl_fcont (ind/2.5,Measured_power_samples[ind]);
  }
  /* plot it already - MoDELED */
  pl_pencolorname ("blue");    /* path will be drawn in red */
  pl_flinewidth (0.4);       /* line thickness in user coordinates */
  pl_fmove(0.0,Modeled_power_samples[0]);
  for (ind=1; ind<250; ind++)
  {
    pl_fcont (ind/2.5,Modeled_power_samples[ind]);
  }

  /* DRAW THE FOLLOWING STUPID LINE!! IT'S IMPORTANT TO DRAW STH NEW CURVE BEFORE FLUSHPL
     BECOZ IT DOESN'T PRINT THE LAST UNFINISHED CONTOUR BABY*/
  pl_fmove(-10.0,-10.0);
  pl_fcont (-15.0,-15.0);

  /*pl_erase ();*/
  pl_flushpl(); /*CHANGED A LOT ALWAYS USE IT!!!!*/

  /*shift the time and power plot */
  for (ind=0; ind<250; ind++)
  {
    time_window[ind]=time_window[ind+1];
    Measured_power_samples[ind]=Measured_power_samples[ind+1];
    Modeled_power_samples[ind]=Modeled_power_samples[ind+1];
  }

  return 1;
}

#if 1
void bargraph(void /*double * comp_powers*/)
{
  static double MAXpwr[NUM_COMPONENTS]={0};
  int ind;
  char str[48];

/* COLORFUL COMP COLORS */
/*  int comp_colors[NUM_COMPONENTS][3] = {
                                        {255, 0, 0},     {0, 255, 0}, {0, 100, 225}, {190, 190, 190},
                                        {210, 180, 140}, {0, 255, 255}, {255, 0, 255}, {255, 255, 0},
                                        {135, 205, 230}, {100, 155, 30}, {30, 90, 155}, {190, 90, 120},
                                        {205, 05, 230}, {100, 55, 230}, {230, 90, 55}, {90, 255, 120},
                                        {122, 190, 255}, {188, 185, 120},{55, 25, 200}, {235, 50, 50},
                                        {45, 200, 55}, {255, 255, 255} };
  /* COMP COLORS FOR PRESENTATION */
  int comp_colors[NUM_COMPONENTS][3] = {
                                        {255, 0, 255},     {255, 0, 255}, {55, 25, 200}, {55, 25, 200},
                                        {45, 200, 55}, {45, 200, 55}, {45, 200, 55}, {45, 200, 55},
                                        {45, 200, 55}, {45, 200, 55}, {45, 200, 55}, {45, 200, 55},
                                        {55, 25, 200}, {55, 25, 200}, {55, 25, 200}, {55, 25, 200},
                                        {255, 0, 0}, {255, 0, 0},{255, 0, 0}, {255, 0, 0},
                                        {255, 0, 0}, {255, 0, 0} };


  /* START THE BARGRAPH */
  pl_selectpl (BARhandle);       /* select the Plotter for use */

  pl_flinewidth (2.0);       /* line thickness in user coordinates */
  pl_pencolorname ("black");    /* path will be drawn in red */
  pl_fmove (0.0, 0.0);    /* position the graphics cursor */

  /* Last chance to erase stuff*/
  pl_erase ();                /* erase Plotter's graphics display */

  /* X axis */
  pl_fcontrel (460.0, 0.0);
  pl_fcont (455.0, 5.0);
  pl_fline (460.0, 0.0, 455.0, -5.0);
  /* Y axis */
  pl_fline (0.0, 0.0, 0.0, 350.0);
  pl_fline (0.0, 350.0, -5.0, 345.0);
  pl_fline (0.0, 350.0, 5.0, 345.0);

  pl_pencolorname ("black");    /* path will be drawn in red */
  pl_linemod ("solid");
  pl_flinewidth (1.0);       /* line thickness in user coordinates */
  /* y axis ticks*/
  pl_fline (5.0, 100.0, -5.0, 100.0);
  pl_fline (5.0, 200.0, -5.0, 200.0);
  pl_fline (5.0, 300.0, -5.0, 300.0);

  /* Set string attributes */
  pl_fontname ("NewCenturySchlbk-Roman"); /* choose a Postscript font */
  pl_ffontsize (15.0);
  /* write Y axis values */
  for (ind=30; ind >= 0; ind=ind - 10)
  {
    pl_fmove (-15.0, 10.0*(double) ind);
    sprintf(str, "%2d", ind);
    pl_alabel ('r', 'c', str);
  }
  /* write Y label */
  pl_fmove (-50.0, 150.0);
  pl_ffontsize (20.0);
  pl_textangle(90);
  pl_alabel ('c', 'c', "Component Powers [W]");
  pl_textangle(0);

  pl_fmove (240.0, 50.0);
  pl_pencolorname ("darkblue");    /* path will be drawn in red */
  pl_ffontsize (15.0);
  /*pl_alabel ('c', 'c', "Components");*/

  /* write TITLE */
  pl_pencolorname ("firebrick3");    /* path will be drawn in red */
  pl_fmove (240.0, 370.0);
  pl_ffontsize (25.0);
  pl_alabel ('c', 'c', "MODELED COMPONENT POWERS");

  /* WRITE COMPONENT NAMES */
  pl_textangle(45);
  pl_ffontsize (14.0);
  for (ind=0; ind<NUM_COMPONENTS; ind++)
  {
    pl_fmove(ind*20.0 + 10.0,-5.0);
    pl_pencolor(comp_colors[ind][0] * 257, comp_colors[ind][1] * 257, comp_colors[ind][2] * 257);
    sprintf(str,"%s",get_comp_name(ind));
    pl_alabel ('r', 'c', str);
  }
  pl_textangle(0);


  /*PRINT MEASURED max-s */
/*  pl_pencolorname ("darkblue");
  pl_flinewidth (0.4);       /* line thickness in user coordinates */
/*  pl_fillcolorname("aquamarine");
  pl_filltype(1);
  pl_fbox(80.0,70.0, 119.0, 80.0);
  pl_filltype(0);
  pl_fmove (100.0, 75.0);
  pl_ffontsize (4.0);
  pl_pencolorname ("lightsalmon4");    /* path will be drawn in red */
/*  sprintf(str, "MAX Power: %5.3f", Measured_current_MAX);

  pl_alabel ('c', 'c', str);

  /* plot THE BARS */
  pl_pencolorname ("darkblue");    /* path will be drawn in red */
  pl_filltype(1);
  pl_ffontsize(10.0);
  for (ind=0; ind<NUM_COMPONENTS; ind++)
  {
    if (component_powers[ind]> 30.0)
      component_powers[ind] = 30.0;
    pl_fillcolor(comp_colors[ind][0] * 257, comp_colors[ind][1] * 257, comp_colors[ind][2] * 257);
    pl_fbox(ind*20.0 + 5.0,0.0, ind*20.0 + 15.0 , 10.0 * component_powers[ind]);
    pl_fmove (ind*20+10.0, 10.0*component_powers[ind]+5.0);
    sprintf(str, "%3.1f", component_powers[ind]);
    pl_alabel ('c', 'c', str);
  }
  pl_filltype(0);

  /* DRAW THE FOLLOWING STUPID LINE!! IT'S IMPORTANT TO DRAW STH NEW CURVE BEFORE FLUSHPL
     BECOZ IT DOESN'T PRINT THE LAST UNFINISHED CONTOUR BABY*/
  pl_fmove(-10.0,-10.0);
  pl_fcont (-15.0,-15.0);

  /*pl_erase ();*/
  pl_flushpl(); /*CHANGED A LOT ALWAYS USE IT!!!!*/

}
#endif

void sampler(void * sock_ptr, unsigned int * dt)
/* does all ether and serial power sampling */
{

  double sample = 0.0;
  char buffer[800];
  int index;
  int sock = (int) sock_ptr;
  /* ALL TIMESTAMPS */
  double timestamp[5];
  /* ALL 24 COUNTED EVENTS */
  double eventcounts[NUM_EVENTS];
  double TOTAL_POWER;
  double FP_rate;

  FILE *powerlog; /* file to write all the powers */

  powerlog = fopen("/home/canturk/C/serial/power_logfile.txt", "w");

  fprintf(powerlog, "\nTIME\tTOTAL_MEASURED_POWER\tTOTAL_MODELED_POWER");
  for(index = 0; index < NUM_COMPONENTS; index++)
  {
       fprintf(powerlog, "\t%-18s", get_comp_name(index) );
  }

  while (1)
  {
    /* FIRST SOCKET READING*/
    /****************************************************/
    /* BELOW IS WHAT WE READ FROM SOCKET */
    socket_read(sock, buffer, sizeof(buffer));
    /****************************************************/

    for(index = 0; index < NUM_EVENTS; index++)
    /* THIS 29 IS # OF ELEMENTS SENT OVER!! SHOULD BE CONSISTENT WITH SERVER */
    {
      if (sscanf(buffer + index * 21, "%lf", &eventcounts[index]) != 1)
      /* THIS 21 IS # OF BYTES PER ELEMENT!! SHOULD BE CONSISTENT WITH SERVER */
      {
         fprintf(stderr, "Error receiving data\n");
         break;
      }
    }
    if (index != 24)
      continue;

    for(index = NUM_EVENTS; index < NUM_EVENTS+5; index++)
    /* THIS 29 IS # OF ELEMENTS SENT OVER!! SHOULD BE CONSISTENT WITH SERVER */
    {
      if (sscanf(buffer + index * 21, "%lf", &timestamp[index - NUM_EVENTS]) != 1)
      /* THIS 21 IS # OF BYTES PER ELEMENT!! SHOULD BE CONSISTENT WITH SERVER */
      {
         fprintf(stderr, "Error receiving data\n");
         break;
      }
    }
    if (index != 29)
      continue;
    /* Now we read the eventcounts & timestamps from ethernet*/


    /* NOW MEASURED POWER SAMPLE FROM SERIAL */
    /*****************************************/
    /* quickly copy the most recent value and run with it */
    pthread_mutex_lock(&port_mutex);
    sample = serial_data;
    /* also restart sample averaging*/
    average = 0.0;
    sample_no = 0;
    pthread_mutex_unlock(&port_mutex);
    /* translate Read Voltage [V] to Processor Power [W] */
    /* 1V = 1000A & Pwr line=12V => P = VxI = 12V x "voltage sample"x1000*/
/*    fprintf(stdout, "\n%5.1f %f ", sec, 12.0*sample*1000.0);


/*    usleep((* dt)); /* wait for sampling interval useconds for next sample */
    /* increment time: by dt/10^6 seconds*/
    sec = sec + ( ((double) (* dt))/1e6 );

    /* ACCESS RATE COMPUTATIONS */
    /*******************************/
    access_rates[Bus_Control] = ((eventcounts[eventcount_IOQallocation] / (timestamp[2]-timestamp[0])) +
                                (3.5 * eventcounts[eventcount_FSBdataactivity] / (timestamp[4]-timestamp[2])));
    access_rates[L2] = (eventcounts[eventcount_BSQcacheref] / (timestamp[4]-timestamp[0]));
    /*access_rates[BPU2ND] = ((8.0*eventcounts[eventcount_ITLBref] / (timestamp[4]-timestamp[0])) +
                           (eventcounts[eventcount_branchretired] / (timestamp[2]-timestamp[0])));*/
    access_rates[BPU2ND] = ((eventcounts[eventcount_ITLBref] / (timestamp[4]-timestamp[0])) +
                           (eventcounts[eventcount_branchretired] / (timestamp[2]-timestamp[0])));
    access_rates[ITLB] = ((eventcounts[eventcount_ITLBref] / (timestamp[4]-timestamp[0])) +
                         (eventcounts[eventcount_BPUfetchreq] / (timestamp[2]-timestamp[0])));
    access_rates[L1] = ((eventcounts[eventcount_LDportreplay] / (timestamp[4]-timestamp[0])) +
                        (eventcounts[eventcount_STportreplay] / (timestamp[4]-timestamp[0])) +
                            (eventcounts[eventcount_Frontend] / (timestamp[4]-timestamp[0])) +
                            (eventcounts[eventcount_UOPtype] / (timestamp[4]-timestamp[0])));
    access_rates[MOB] = (eventcounts[eventcount_MOBloadreplay] / (timestamp[4]-timestamp[2]));
    access_rates[MEMcont] = (1- (eventcounts[eventcount_machineclear] / (timestamp[4]-timestamp[2])));
    access_rates[DTLB] = access_rates[L1] + access_rates[MOB];
    access_rates[FPE] = ((eventcounts[eventcount_PackedSPuop] + eventcounts[eventcount_PackedDPuop]) / (timestamp[1]-timestamp[0])) +
                        ((eventcounts[eventcount_scalarSPuop] + eventcounts[eventcount_scalarDPuop]) / (timestamp[2]-timestamp[1])) +
                        ((eventcounts[eventcount_64bitMMXuop] + eventcounts[eventcount_128bitMMXuop]) / (timestamp[3]-timestamp[2])) +
                        ((eventcounts[eventcount_x87FPuop] + eventcounts[eventcount_x87SIMDmovesuop]) / (timestamp[4]-timestamp[3]));
/*    access_rates[INTE] = 2.0*((eventcounts[eventcount_UOPqueuewrites07] / (timestamp[4]-timestamp[0])) -
                         (((eventcounts[eventcount_PackedSPuop]/4 + eventcounts[eventcount_PackedDPuop]/4) / (timestamp[1]-timestamp[0])) +
                        ((eventcounts[eventcount_scalarSPuop] + eventcounts[eventcount_scalarDPuop]) / (timestamp[2]-timestamp[1])) +
                        ((eventcounts[eventcount_64bitMMXuop]/4 + eventcounts[eventcount_128bitMMXuop]/8) / (timestamp[3]-timestamp[2])) +
                        ((eventcounts[eventcount_x87FPuop] + eventcounts[eventcount_x87SIMDmovesuop]/4) / (timestamp[4]-timestamp[3]))))
                        - access_rates[L1] - (eventcounts[eventcount_branchretired] / (timestamp[2]-timestamp[0]));*/
    access_rates[INTE] = (eventcounts[eventcount_UOPqueuewrites07] / (timestamp[4]-timestamp[0])) -
                         (((eventcounts[eventcount_PackedSPuop]/4 + eventcounts[eventcount_PackedDPuop]/4) / (timestamp[1]-timestamp[0])) +
                        ((eventcounts[eventcount_scalarSPuop] + eventcounts[eventcount_scalarDPuop]) / (timestamp[2]-timestamp[1])) +
                        ((eventcounts[eventcount_64bitMMXuop]/4 + eventcounts[eventcount_128bitMMXuop]/8) / (timestamp[3]-timestamp[2])) +
                        ((eventcounts[eventcount_x87FPuop] + eventcounts[eventcount_x87SIMDmovesuop]/4) / (timestamp[4]-timestamp[3])));
    access_rates[INTE] = MAX(access_rates[INTE],0.0); /* TO avoid negative rate */
    access_rates[INTR] = access_rates[INTE];
    access_rates[FPR] = access_rates[FPE];
    access_rates[ID] = (eventcounts[eventcount_TCdelivermode] / (timestamp[4]-timestamp[0]));
    access_rates[TC] = (eventcounts[eventcount_UOPqueuewrites07] / (timestamp[4]-timestamp[0]));
    access_rates[BPU1ST] = (eventcounts[eventcount_branchretired] / (timestamp[2]-timestamp[0]));
    access_rates[ROM] = (eventcounts[eventcount_UOPqueuewrites04] / (timestamp[4]-timestamp[0]));
    access_rates[ALLOC] = (eventcounts[eventcount_UOPqueuewrites07] / (timestamp[4]-timestamp[0]));
    access_rates[REN] = access_rates[ALLOC];
    access_rates[IQ] = access_rates[ALLOC];
    access_rates[IQ2] = access_rates[ALLOC];
    access_rates[SCH] = access_rates[ALLOC];
    access_rates[RETIRE] = (eventcounts[eventcount_UOPSretired] / (timestamp[4]-timestamp[0]));


    /* POWER COMPUTATIONS */
    /**********************/
    /* DONE very inefficiently here */
    component_powers[Bus_Control] = MIN(access_rates[Bus_Control] * 80.0, 7.0) /*3.9*/;
    component_powers[L2] = MIN(access_rates[L2] * 300.0,6.0) /*10.6*/;
    component_powers[BPU2ND] = access_rates[BPU2ND] * 15.5 /*2.5*/;
    component_powers[ITLB] = access_rates[ITLB] * 4.20 /*1.15*/;
    component_powers[L1] = MIN(access_rates[L1] * 10.2 + access_rates[MOB] * 10.2,6.0) /*4.2*/;
    component_powers[MOB] = access_rates[MOB] * 4.95 /*1.95*/;
    component_powers[MEMcont] = access_rates[MEMcont] * 0.72 + access_rates[L1] *2.2/*0.72*/;
    component_powers[DTLB] = access_rates[DTLB] * 4.3 /*2.3*/;
    component_powers[INTE] = access_rates[INTE] * 3.44 /*1.44*/;
    component_powers[FPE] = access_rates[FPE] * 4.5 /*4.5*/;
    component_powers[INTR] = access_rates[INTR] * 0.94 /*1.44*/;
    component_powers[FPR] = access_rates[FPR] * 0.8 /*1.8*/;
    component_powers[ID] = access_rates[ID] * 5.3 /*2.3*/;
    component_powers[BPU1ST] = access_rates[BPU1ST] * 10.53 /*3.53*/;
    component_powers[ROM] = access_rates[ROM] * 10.16 /*2.16*/;
    /* WE NEED to consider clock power for these when not udle */
    if (access_rates[ALLOC] > 0.028)
    {
      component_powers[TC] = access_rates[TC] * 4.0 + 2.0/*6.2*/;
      component_powers[ALLOC] = access_rates[ALLOC] * 0.42 + 1.5/*1.22*/;
      component_powers[REN] = access_rates[REN] * 0.66 + 1.5/*1.66*/;
      component_powers[IQ] = access_rates[IQ] * 0.44 + 0.8/*1.44*/;
      component_powers[IQ2] = access_rates[IQ2] * 1.02 +0.8/*3.024*/;
      component_powers[SCH] = access_rates[SCH] * 0.4 + 1.5/*2.4*/;
      component_powers[RETIRE] = access_rates[RETIRE] * 0.5 + 2.0/*4.68*/;
    }
    else
    {
      component_powers[TC] = access_rates[TC] * 4.0 /*6.2*/;
      component_powers[ALLOC] = access_rates[ALLOC] * 0.42 /*1.22*/;
      component_powers[REN] = access_rates[REN] * 0.66 /*1.66*/;
      component_powers[IQ] = access_rates[IQ] * 0.44 /*1.44*/;
      component_powers[IQ2] = access_rates[IQ2] * 1.02 /*3.024*/;
      component_powers[SCH] = access_rates[SCH] * 0.4 /*2.4*/;
      component_powers[RETIRE] = access_rates[RETIRE] * 0.5 /*4.68*/;
    }



    /* TOTAL POWER */
    TOTAL_POWER = IDLE_POWER;
    for (index = 0; index<NUM_COMPONENTS; index++)
      TOTAL_POWER = TOTAL_POWER + component_powers[index];

    fprintf(stdout,"  \n Delta t: %f TOTAL POWER [W]:    %10.8f \n\n",(timestamp[4]-timestamp[0])/1384.230e6,TOTAL_POWER);

    /* PRINT THE COUNTER VALUES: */
    /* DON"t print anymore */
    for(index = 0; index < NUM_EVENTS; index++)
    /* THIS 29 IS # OF ELEMENTS SENT OVER!! SHOULD BE CONSISTENT WITH SERVER */
    {
         fprintf(stdout, "%2d) %-18s: %10.10lf \n",index, get_event_name(index), eventcounts[index]/(timestamp[4]-timestamp[0]));
    }
    /* PRINT THE ACCESS RATES: */
    /*for(index = 0; index < NUM_COMPONENTS; index++)
    {
         fprintf(stdout, "%2d) %-18s: %10.10lf \n",index, get_comp_name(index), access_rates[index]);
    }
    /* TIMES */
    for(index = NUM_EVENTS; index < NUM_EVENTS+5; index++)
      {
         fprintf(stdout, "\nTimes[%d]: %20.0lf\n", index, timestamp[index-NUM_EVENTS]);
      }

    /* LOG ALL DATA */
    /***************/
    fprintf(powerlog, "\n%11.8lf\t%11.8lf\t%11.8lf", sec, 12.0*sample*1000.0, TOTAL_POWER);
    for(index = 0; index < NUM_COMPONENTS; index++)
    {
         fprintf(powerlog, "\t%11.8lf", component_powers[index]);
    }

    plotter(sec, 12.0*sample*1000.0, TOTAL_POWER);

    bargraph();
  }
}

/* - serial port input loop */
/* Polls the serial port continuously */
void poll_serialPORT(void * nothing)
{
  int read_pointer;
  float sample;
  char buffer[MAX_CHAR];

  /* open serial port for READ*/
  serial = fopen("/dev/ttyS0", "r");
  if (serial == NULL)
  {
    perror("Could not open serial port");
    exit(-1);
  }
  /* initialize sample no and current average*/
  sample_no = 0;
  average = 0;
  while (1)
  {
    /* read from serial port into buffer*/
    read_pointer = (int) fgets(buffer, sizeof(buffer), serial);
    if (read_pointer == EOF)
    {
      perror("Could not read from serial port\n");
      exit(-1);
    }
    /* transfer ascii to binary value */
    sscanf(buffer, "%f\n", &sample);
    /*fprintf(stdout, "\nsample: %f", sample);*/
    sample_no++;
    average = (((sample_no -1) * average + sample) / ((float) sample_no));
    /* quickly write data */
    pthread_mutex_lock(&port_mutex);
    serial_data = average;
    pthread_mutex_unlock(&port_mutex);
  }
}

int main(int argc, char **argv)
{
  const static unsigned int dt = 440*1000; /* sampling period (delta t) for serial data [Useconds] */

  pthread_t SerialPoll_thread;
  /*pthread_t sampler_thread;*/

  /* get 2 cmd line params*/
  if (argc != 3)
  {
    fprintf(stderr, "Usage: %s <SERVERNAME> <portnum>\n", argv[0]);
    exit(1);
  }

  /*cpu_sock = init_network("karelian", "1234");*/
  cpu_sock = init_network(argv[1], argv[2]);

  /* PLOTTER STUFF */
  /* set a Plotter parameter */
  pl_parampl ("PAGESIZE", "letter");
/*  pl_parampl ("USE_DOUBLE_BUFFERING", "fast");*/
  /* apparently threading (-lpthread) messes up double buffering */
  pl_parampl ("BG_COLOR", "azure3");


  /* create a X Plotter that writes to standard output */
  if ((handle = pl_newpl ("X", stdin, stdout, stderr)) < 0)
    {
      fprintf (stderr, "Couldn't create Plotter\n");
      return 1;
    }
  if ((BARhandle = pl_newpl ("X", stdin, stdout, stderr)) < 0)
    {
      fprintf (stderr, "Couldn't create 2nd Plotter\n");
      return 1;
    }
  pl_selectpl (handle);       /* select the Plotter for use */
  if (pl_openpl () < 0)       /* open Plotter */
    {
      fprintf (stderr, "Couldn't open Plotter\n");
      return 1;
    }
  pl_fspace (-20.0, -20.0, 120.0, 90.0); /* specify user coor system */
  pl_selectpl (BARhandle);       /* select the Plotter for use */
  if (pl_openpl () < 0)       /* open Plotter */
    {
      fprintf (stderr, "Couldn't open 2nd Plotter\n");
      return 1;
    }
  pl_fspace (-80.0, -100.0, 500.0, 400.0); /* specify user coor system */
  /* will make one bar every 20 x distance */


  /* THREAD STUFF */
  /* launch separate thread to read serial port */
  pthread_mutex_init(&port_mutex, NULL); /* initialize mutex*/
  /* create the polling thread*/
  if (pthread_create(&SerialPoll_thread, NULL, (void *) poll_serialPORT, NULL))
  {
    fprintf(stderr, "\nSERIAL PORT THREAD COULD NOT START\n\n");
    exit(0);
  }
/*  if (pthread_create(&sampler_thread, NULL, (void *) sampler, (void *) &dt))*/
  /* Last param: address of passed sampling period */
/*  {
    fprintf(stderr, "\nSAMPLER THREAD COULD NOT START\n\n");
    exit(0);
  }*/

  /* MAIN DOES NOTHING NOW, JUST SITS N WAITS */
  sampler((void *) cpu_sock, (void *) &dt);
  /* MAKE main func-n wait until threadS finish*/
  pthread_join(SerialPoll_thread, NULL);
  /*pthread_join(sampler_thread, NULL);*/

  if (pl_closepl () < 0)      /* close Plotter */
    {
      fprintf (stderr, "Couldn't close Plotter\n");
      return 1;
    }

  pl_selectpl (0);            /* select default Plotter */
  if (pl_deletepl (handle) < 0) /* delete Plotter we used */
    {
      fprintf (stderr, "Couldn't delete Plotter\n");
      return 1;
    }

  return 0;

}
